/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: callbacks.h,v 1.1 2006/02/24 17:34:57 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: callbacks.h,v $
 * Revision 1.1  2006/02/24 17:34:57  pipas
 * Initial revision
 *
 */
#ifndef CALLBACKS_H
#define CALLBACKS_H

#include <gnome.h>
#include "cuiterm.h"
#include "cuiterminal.h"
#include "dirhistory.h"
#include "popup_menus.h"
#include "bookmarks.h"
#include "configure.h"
#include "dnd.h"
#include "history.h"      /* This file contains more callback functions */

#define UNIMPLEMENTED unimplemented(__func__, __FILE__, __LINE__)

void 
unimplemented(const char *function_name, 
		const char *filename,
		gint linenumber);

void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_main_widget_realize                 (GtkWidget       *widget,
                                        gpointer         user_data);

gboolean
on_main_widget_key_press_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_main_widget_key_release_event       (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_app1_delete_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean
on_main_widget_button_press_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_main_widget_expose_event            (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

GtkWidget*
create_history_combobox (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);


void
on_repeat_toolbutton_clicked           (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_abort_toolbutton_clicked            (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_home_toolbutton_clicked             (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_filesystem_radiotoolbutton_clicked  (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_network_radiotoolbutton_clicked     (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_programmer_radiotoolbutton_clicked  (GtkToolButton   *toolbutton,
                                        gpointer         user_data);


gboolean
on_main_widget_motion_notify_event     (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_main_widget_leave_notify_event      (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data);

void
on_directory_listing_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_ls_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_tree_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_basic_operations_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cp_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_dd_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_install_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_mv_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_rm_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_shred_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_special_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_ln_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_mkdir_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_rmdir_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_mkfifo_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_mknod_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_changing_file_attributes1_activate  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_chgrp_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_chmod_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_chown_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_touch_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_disk_usage_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_df_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_du_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_stat_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_sync_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_user_information_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_who_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_w_activate                          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_id_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_logname_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_whoami_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_group_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

gboolean
on_main_widget_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void
on_radio_button_arrow_realize          (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_radio_button_text_realize           (GtkWidget       *widget,
                                        gpointer         user_data);


void
on_radio_button_objects_realize        (GtkWidget       *widget,
                                        gpointer         user_data);

gboolean
on_properties_window_focus_out_event   (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data);

void
on_slice_help_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_slice_close_button_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_slice_text_view_realize             (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_loggen_in_users_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);


void
on_view_size_bars_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_file_convert_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_convert_to_png_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);





void
on_radio_button_arrow_toggled          (GtkToggleToolButton *toggletoolbutton,
                                        gpointer         user_data);

void
on_radio_button_text_toggled           (GtkToggleToolButton *toggletoolbutton,
                                        gpointer         user_data);

void
on_radio_button_objects_toggled        (GtkToggleToolButton *toggletoolbutton,
                                        gpointer         user_data);





void
on_secondary_widget_realize            (GtkWidget       *widget,
                                        gpointer         user_data);

gboolean
on_secondary_widget_expose_event       (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

gboolean
on_secondary_widget_button_press_event (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_secondary_widget_key_press_event    (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);
gboolean
on_secondary_widget_key_release_event  (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);


void
on_app1_map                            (GtkWidget       *widget,
                                        gpointer         user_data);

gboolean
on_secondary_widget_motion_notify_event
                                        (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_secondary_widget_button_release_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

#endif

gboolean
on_secondary_widget_leave_notify_event (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data);

void
on_secondary_widget_map                (GtkWidget       *widget,
                                        gpointer         user_data);


void
on_main_widget_drag_begin              (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

void
on_search_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cancel_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_search_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_view_window_frames_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_view_syntax_highlight_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_view_active_areas_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_view_menu_areas_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_view_entry_areas_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_view_font_settings_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_search_window_realize               (GtkWidget       *widget,
                                        gpointer         user_data);


void
on_make_toolbutton_realize             (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_make_toolbutton_clicked             (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_configure_toolbutton_realize        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_configure_toolbutton_clicked        (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_make_dist_toolbutton_realize        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_make_dist_toolbutton_clicked        (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_make_install_toolbutton_realize     (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_make_install_toolbutton_clicked     (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_show_software_project_toolbar_activate
                                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_softw_proj_toolbar_realize          (GtkWidget       *widget,
                                        gpointer         user_data);



void
on_set_colors_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_syntax_highlight_window_realize     (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_syntax_highlight_close_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_make_clean_toolbutton_clicked       (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_style_categories_treeview_realize   (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_style_categories_treeview_row_activated
                                        (GtkTreeView     *treeview,
                                        GtkTreePath     *path,
                                        GtkTreeViewColumn *column,
                                        gpointer         user_data);

void
on_style_categories_treeview_cursor_changed
                                        (GtkTreeView     *treeview,
                                        gpointer         user_data);

void
on_color_colorselection_color_changed  (GtkColorSelection *colorselection,
                                        gpointer         user_data);

void
on_background_colorselection_color_changed
                                        (GtkColorSelection *colorselection,
                                        gpointer         user_data);

void
on_show_latex_project_toolbar_activate (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_tex_files_toolbuton_realize         (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_tex_files_toolbuton_clicked         (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_dvi_files_toolbutton_realize        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_dvi_files_toolbutton_clicked        (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_ps_files_toolbutton_realize         (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_ps_files_toolbutton_clicked         (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_pdf_files_toolbutton_realize        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_pdf_files_toolbutton_clicked        (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_latex_project_toolbar_realize       (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_edit_bookmarks_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_show_history_window_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_shell_combobox_changed              (GtkComboBox     *combobox,
                                        gpointer         user_data);

void
on_shell_filechooserbutton_realize     (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_shell_combobox_realize              (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_different_language_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_text_editor_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_gui_completion_button_clicked       (GtkToolButton   *toolbutton,
                                        gpointer         user_data);

void
on_command_dialog_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_app1_realize                        (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_main_scrolledwindow_scroll_child    (GtkScrolledWindow *scrolledwindow,
                                        GtkScrollType    scroll,
                                        gboolean         horizontal,
                                        gpointer         user_data);


GtkWidget*
cui_terminal_widget_new (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

void
on_new2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_open2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save_as2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_quit2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cut2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_paste2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clear2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_preferences2_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);


void
on_save_as3_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);


