/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: configure.h,v 1.1 2006/02/24 17:34:14 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: configure.h,v $
 * Revision 1.1  2006/02/24 17:34:14  pipas
 * Initial revision
 *
 */
#ifndef CONFIGURE_H
#define CONFIGURE_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define _GNU_SOURCE
#include <glib.h>

/****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

void bg_conf_init(void);

gchar *bg_conf_get_string(const gchar *name, gchar *def);
gchar *bg_conf_set_string(const gchar *name, gchar *value);
gboolean bg_conf_get_bool(const gchar *name, gboolean def);
gboolean bg_conf_set_bool(const gchar *name, gboolean value);
gboolean bg_conf_set_bool(const gchar *name, gboolean value);
gdouble bg_conf_get_double(const gchar *name, gdouble def);
	
gint bg_conf_get_int(const gchar *name, gint def);
gint bg_conf_set_int(const gchar *name, gint value);

GdkColor *bg_conf_set_color(const gchar *name, const GdkColor *color);

gchar *bg_conf_get_default_editor(gchar *filename);
gchar *bg_conf_get_default_ls_options(gboolean long_listing);

void on_properties_window_realize(GtkWidget *widget, gpointer user_data);
void on_properties_cancel_button_clicked(GtkButton *button, gpointer user_data);
void on_properties_ok_button_clicked(GtkButton *button, gpointer user_data);
void on_init_commands_textview_realize(GtkWidget *widget, gpointer user_data);
gboolean bg_conf_save_window_coord(GtkWidget *widget, gchar *name);
gboolean bg_conf_restore_window_coord(GtkWidget *widget, gchar *name);

/*
 * Higher level functions.
 */
gchar *bg_conf_get_default_text_editor(void);

#endif
